<?php

namespace dgsoft\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VehicleAvailRQCoreTypeVendorPrefsVendorPref StructType
 * @package Dg
 * @subpackage Structs
 */
class DgVehicleAvailRQCoreTypeVendorPrefsVendorPref extends DgCompanyNamePrefType
{
    /**
     * The _
     * @var \dgsoft\StructType\DgCompanyNamePrefType
     */
    public $_;
    /**
     * The CorpDiscountNmbr
     * @var string
     */
    public $CorpDiscountNmbr;
    /**
     * Constructor method for VehicleAvailRQCoreTypeVendorPrefsVendorPref
     * @uses DgVehicleAvailRQCoreTypeVendorPrefsVendorPref::set_()
     * @uses DgVehicleAvailRQCoreTypeVendorPrefsVendorPref::setCorpDiscountNmbr()
     * @param \dgsoft\StructType\DgCompanyNamePrefType $_
     * @param string $corpDiscountNmbr
     */
    public function __construct(\dgsoft\StructType\DgCompanyNamePrefType $_ = null, $corpDiscountNmbr = null)
    {
        $this
            ->set_($_)
            ->setCorpDiscountNmbr($corpDiscountNmbr);
    }
    /**
     * Get _ value
     * @return \dgsoft\StructType\DgCompanyNamePrefType|null
     */
    public function get_()
    {
        return $this->_;
    }
    /**
     * Set _ value
     * @param \dgsoft\StructType\DgCompanyNamePrefType $_
     * @return \dgsoft\StructType\DgVehicleAvailRQCoreTypeVendorPrefsVendorPref
     */
    public function set_(\dgsoft\StructType\DgCompanyNamePrefType $_ = null)
    {
        $this->_ = $_;
        return $this;
    }
    /**
     * Get CorpDiscountNmbr value
     * @return string|null
     */
    public function getCorpDiscountNmbr()
    {
        return $this->CorpDiscountNmbr;
    }
    /**
     * Set CorpDiscountNmbr value
     * @param string $corpDiscountNmbr
     * @return \dgsoft\StructType\DgVehicleAvailRQCoreTypeVendorPrefsVendorPref
     */
    public function setCorpDiscountNmbr($corpDiscountNmbr = null)
    {
        // validation for constraint: string
        if (!is_null($corpDiscountNmbr) && !is_string($corpDiscountNmbr)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($corpDiscountNmbr)), __LINE__);
        }
        $this->CorpDiscountNmbr = $corpDiscountNmbr;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\StructType\DgVehicleAvailRQCoreTypeVendorPrefsVendorPref
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
